=== debian/changelog ===
bwa-mem2 (2.2.1-1) unstable; urgency=medium

  * Initial release. (Closes: #950607)

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 18 Nov 2021 18:55:34 +0100
