=== debian/control ===
Source: bwa-mem2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Dylan Aïssi <daissi@debian.org>,
           Michael R. Crusoe <crusoe@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               zlib1g-dev,
               libsimde-dev,
               help2man
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/bwa-mem2
Vcs-Git: https://salsa.debian.org/med-team/bwa-mem2.git
Homepage: https://github.com/bwa-mem2/bwa-mem2
Rules-Requires-Root: no

Package: bwa-mem2
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Sequence alignment using Burrows-Wheeler Transform
 BWA is a software package for mapping low-divergent sequences against
 a large reference genome, such as the human genome. It consists of
 three algorithms: BWA-backtrack, BWA-SW and BWA-MEM. The first
 algorithm is designed for Illumina sequence reads up to 100bp, while
 the rest two for longer sequences ranged from 70bp to 1Mbp. BWA-MEM
 and BWA-SW share similar features such as long-read support and split
 alignment, but BWA-MEM, which is the latest, is generally recommended
 for high-quality queries as it is faster and more accurate. BWA-MEM
 also has better performance than BWA-backtrack for 70-100bp Illumina
 reads.
