=== debian/rules ===
#!/usr/bin/make -f
SHELL=bash  # needed for the <(echo …) process subsitution temporary file

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
export DEB_CFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_CXXFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
endif

%:
	dh $@

override_dh_auto_build:
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	dh_auto_build -- EXE=bwa-mem2.sse2 ARCH_FLAGS='-msse2'
	dh_auto_build -- multi
else
	dh_auto_build -- ARCH_FLAGS=' '
endif
	help2man --no-discard-stderr --version-string="$(DEB_VERSION_UPSTREAM)" \
		--help-option=' ' --no-info ./bwa-mem2 --name="Sequence alignment using Burrows-Wheeler Transform" \
		> debian/bwa-mem2.1
	help2man --no-discard-stderr --version-string="$(DEB_VERSION_UPSTREAM)" \
		--help-option=' ' --no-info './bwa-mem2 mem' \
		--include <(echo -e "[NAME]\nbwa-mem2_mem \- Sequence alignment using Burrows-Wheeler Transform") \
		> debian/bwa-mem2-mem.1

# ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
# 	dh_auto_build --sourcedir=test -- CXX=g++
# endif
#
# override_dh_auto_test:
# ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
# 	cd test; for test in fmi_test smem2_test bwt_seed_strategy_test sa2ref_test xeonbsw; do ./$${test}; done
# endif


override_dh_auto_clean:
	dh_auto_clean || true
