=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)Source_code_including_submodules\.tar\.gz%@PACKAGE@-$1.tar.gz%,uversionmangle=s/pre/~pre/" \
  https://github.com/@PACKAGE@/@PACKAGE@/releases .*/download/v@ANY_VERSION@/Source_code_including_submodules@ARCHIVE_EXT@
