## bwa-mem2 2.3+ds

=== debian/changelog ===
bwa-mem2 (2.3+ds-1) unstable; urgency=medium

  * d/watch: upgrade to uscan 5 syntax
  * New upstream version
  * Standards-Version: 4.7.3 (routine-update)
  * debputy lint --auto-fix (routine-update)
  * Removed many patches that were applied upstream.
  * Add +ds suffix, as we removed the ".git" directory from the upstream
    tarball.
  * d/clean: enable repeat builds

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 21 Feb 2026 12:18:48 +0100
