=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                zlib1g-dev,
                libsimde-dev,
                help2man
-Standards-Version: 4.6.0
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/med-team/bwa-mem2
 Vcs-Git: https://salsa.debian.org/med-team/bwa-mem2.git
 Homepage: https://github.com/bwa-mem2/bwa-mem2
