=== debian/watch ===
Version: 5

Source: https://api.github.com/repos/bwa-mem2/bwa-mem2/releases
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/tarball/v@ANY_VERSION@
Download-Url-Mangle: s%api.github.com/repos/([^/]+/[^/]+)/tarball/v@ANY_VERSION@%github.com/$1/releases/download/v$2/Source_code_including_submodules.zip%g
Filename-Mangle: s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%
Dversion-Mangle: auto
Repack-Suffix: +ds
Search-Mode: plain
